---
title: Box alignment in grid layout
slug: Web/CSS/CSS_Box_Alignment/Box_Alignment_In_Grid_Layout
tags:
  - CSS
  - Guide
  - box alignment
  - grid
---
<div>{{CSSRef}}</div>

<p class="summary">The <a href="/en-US/docs/Web/CSS/CSS_Box_Alignment">Box Alignment</a> specification details how alignment works in various layout methods. On this page we explore how box alignment works in the context of <a href="/en-US/docs/Web/CSS/CSS_Grid_Layout">CSS Grid Layout</a>. </p>

<p>As this page aims to detail things which are specific to CSS Grid Layout and Box Alignment, it should be read in conjunction with the main <a href="/en-US/docs/Web/CSS/CSS_Box_Alignment">Box Alignment</a> page which details the common features of box alignment across layout methods.</p>

<h2 id="Basic_Example">Basic Example</h2>

<p>In this example using grid layout, there is extra space in the grid container after laying out the fixed width tracks on the inline (main) axis. This space is distributed using <code>justify-content</code>. On the block (cross) axis the alignment of the items inside their grid areas is controlled with <code>align-items</code>. The first item overrides the <code>align-items</code> value set on the group by setting <code>align-self</code> to <code>center</code>.</p>

<p>{{EmbedGHLiveSample("css-examples/box-alignment/overview/grid-align-items.html", '100%', 500)}}</p>

<h2 id="Grid_axes">Grid axes</h2>

<p>As a two-dimensional layout method, when working with grid layout we always have two axes on which to align our items. We have access to all of the box alignment properties to help us achieve this.</p>

<p>The inline axis is the axis that corresponds to the direction that words in a sentence would run in the writing mode used. Therefore, in a horizontal language such as English or Arabic the inline direction runs horizontally. Should you be in a vertical writing mode the inline axis will run vertically.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/15962/Inline_Axis.png" style="height: 306px; width: 940px;"></p>

<p>To align things on the inline axis you use the properties that start with <code>justify-</code>, {{cssxref("justify-content")}}, {{cssxref("justify-items")}} and {{cssxref("justify-self")}}.</p>

<p>The block axis crosses the inline axis in the direction that blocks are displayed down the page — for example paragraphs in English are displayed one below the other vertically. This, therefore is the block dimension.</p>

<p>To align things on the block axis you use the properties that start with <code>align-</code>, {{cssxref("align-content")}}, {{cssxref("align-items")}} and {{cssxref("align-self")}}.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/15961/Block_Axis.png" style="height: 306px; width: 940px;"></p>

<h2 id="Self_alignment">Self alignment</h2>

<ul>
 <li>{{cssxref("justify-self")}}</li>
 <li>{{cssxref("align-self")}}</li>
 <li>{{cssxref("place-self")}}</li>
 <li>{{cssxref("justify-items")}}</li>
 <li>{{cssxref("align-items")}}</li>
 <li>{{cssxref("place-items")}}</li>
</ul>

<p>These properties deal with aligning the item inside the grid area it is placed into. The properties <code>align-items</code> and <code>justify-items</code> are applied to the grid container and set the <code>align-self</code> and <code>justify-self</code> properties as a group. This means that you can set alignment for all of your grid Items at once, then override any items that need a different alignment by applying the <code>align-self</code> or <code>justify-self</code> property to the rules for the individual grid Items.</p>

<p>The initial value for <code>align-self</code> and <code>justify-self</code> is <code>stretch</code> so the item will stretch over the entire grid area. The exception to this rule is where the item has an intrinsic aspect ratio, for example an image. In this case the item will be aligned to <code>start</code> in both dimensions in order that the image is not distorted.</p>

<h2 id="Content_alignment">Content alignment</h2>

<ul>
 <li>{{cssxref("justify-content")}}</li>
 <li>{{cssxref("align-content")}}</li>
 <li>{{cssxref("place-content")}}</li>
</ul>

<p>These properties deal with aligning the tracks of the grid when there is extra space to distribute. This scenario will occur if the tracks that you have defined total less than the total width of the grid container.</p>

<h2 id="Gap_and_legacy_grid-gap_properties">Gap and legacy grid-gap properties</h2>

<ul>
 <li>{{cssxref("row-gap")}}</li>
 <li>{{cssxref("column-gap")}}</li>
 <li>{{cssxref("gap")}}</li>
 <li>{{cssxref("grid-row-gap")}}</li>
 <li>{{cssxref("grid-column-gap")}}</li>
 <li>{{cssxref("grid-gap")}}</li>
</ul>

<p>The Grid specification originally contained the definition for the properties {{cssxref("grid-row-gap")}}, {{cssxref("grid-column-gap")}} and {{cssxref("grid-gap")}}. These have since been moved into the Box Alignment specification and renamed to {{cssxref("row-gap")}}, {{cssxref("column-gap")}}, and {{cssxref("gap")}}. This allows them to be used for other layout methods where a gap between items makes sense.</p>

<p>The updated properties have not yet been implemented in all browsers. Therefore, to use the gap properties in grid layout, you should use the <code>grid-row-gap</code>, <code>grid-column-gap</code> and <code>grid-gap</code> versions to ensure full compatibility. You could double up the properties and use both as you would for vendor prefixes.</p>

<h2 id="Reference">Reference</h2>

<h3 id="CSS_Properties">CSS Properties</h3>

<div class="index">
<ul>
 <li>{{cssxref("justify-content")}}</li>
 <li>{{cssxref("align-content")}}</li>
 <li>{{cssxref("place-content")}}</li>
 <li>{{cssxref("justify-items")}}</li>
 <li>{{cssxref("align-items")}}</li>
 <li>{{cssxref("place-items")}}</li>
 <li>{{cssxref("justify-self")}}</li>
 <li>{{cssxref("align-self")}}</li>
 <li>{{cssxref("place-self")}}</li>
 <li>{{cssxref("row-gap")}}</li>
 <li>{{cssxref("column-gap")}}</li>
 <li>{{cssxref("gap")}}</li>
</ul>
</div>

<h3 id="Glossary_Entries">Glossary Entries</h3>

<div class="index">
<ul>
 <li><a href="/en-US/docs/Glossary/Cross_Axis">Cross Axis</a></li>
 <li><a href="/en-US/docs/Glossary/Main_Axis">Main Axis</a></li>
</ul>
</div>

<h2 id="Guides">Guides</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Box_Alignment_in_CSS_Grid_Layout">Alignment in grid layout</a></li>
</ul>

<h2 id="External_Resources">External Resources</h2>

<ul>
 <li><a href="https://rachelandrew.co.uk/css/cheatsheets/box-alignment">Box alignment cheatsheet</a></li>
 <li><a href="https://www.smashingmagazine.com/2016/11/css-grids-flexbox-box-alignment-new-layout-standard/">CSS Grid, Flexbox and Box Alignment</a></li>
 <li><a href="https://blogs.igalia.com/jfernandez/2017/05/03/can-i-use-css-box-alignment/">Thoughts on partial implementations of Box Alignment</a></li>
</ul>
